#include "Ast.h"


Ast::Ast(int val)
{
  is_leaf = true;
  this->val = val;
  is_op = false;
}


Ast::Ast(op_t op, Ast* left, Ast* right)
{
  is_leaf = false;
  is_op = true;
  this->op = op;
  left_son = left;
  right_son = right;
}


ostream& operator <<(ostream& sout, Ast& ast)
{
  if(ast.is_leaf) sout << ast.val;
  else
    {
      sout << "(" << *(ast.left_son) << ")";
      if(ast.op == ADD)
	sout << "+";
      if(ast.op == SUB)
	sout << "-";
      if(ast.op == MUL)
	sout << "*";
      sout << "(" << *(ast.right_son) << ")";
    }
  return sout;
}
