#ifndef __AST_H
#define __AST_H

#include <iostream>
using namespace std;

enum op_t
  {
    ADD, SUB, MUL
  };


class Ast
{
 public:
  int is_leaf;
  int val;

  int is_op;
  op_t op;
  Ast* left_son;
  Ast* right_son;

  Ast(int val);
  Ast(op_t op, Ast* left, Ast* right);
};

ostream& operator <<(ostream& sout, Ast& ast);

#endif
